structures (22 October 2003) | index /home/todd/release/pdb2pqr/structures.py

`Structures for PDB2PQR
This module contains the structure objects used in PDB2PQR and their
associated methods.
Todd Dolinsky (todd@ccb.wustl.edu)
Washington University in St. Louis`

Modules

``

string | sys |  |

Classes

``

pdb.ATOM
  Atom
Chain
Residue

class Atom(pdb.ATOM)
`` | `Class Atom The Atom class inherits off the ATOM object in pdb.py. It is used for adding fields not found in the pdb that may be useful for analysis. Also simplifies code by combining ATOM and HETATM objects into a single class.`

Methods defined here:

__init__(self, atom, type, residue)
  `Initialize the new Atom object by using the old object.
  Parameters
  atom: The original ATOM object (ATOM)
  type: Either ATOM or HETATM (string)
  residue: A pointer back to the parent residue object (Residue)`

__str__(self)
  `Returns a string of the new atom type. Uses the ATOM string
  output but changes the first field to either by ATOM or
  HETATM as necessary.
  Returns
  out: String with ATOM/HETATM field set appropriately`

addExtraBond(self, bondedatom)
  `Add a bond to the list of extrabonds
  Parameters:
  bondedatom: The atom to bond to (Atom)`

addIntraBond(self, bondedatom)
  `Add a bond to the list of intrabonds
  Parameters:
  bondedatom: The atom to bond to (Atom)`

get(self, name)
  `Get a member of the Atom class
  Parameters
  name: The name of the member (string)
  Possible Values
  type: The type of Atom (either ATOM or HETATM)
  serial: Atom serial number
  name: Atom name
  altLoc: Alternate location
  resName: Residue name
  chainID: Chain identifier
  resSeq: Residue sequence number
  iCode: Code for insertion of residues
  x: Orthogonal coordinates for X in Angstroms.
  y: Orthogonal coordinates for Y in Angstroms.
  z: Orthogonal coordinates for Z in Angstroms.
  occupancy: Occupancy
  tempFactor: Temperature Factor
  segID: Segment identifier
  element: Element symbol
  charge: Charge on the atom
  bonds: The bonds associated with the atom
  interbonds: The intrabonds associated with the atom
  extrabonds: The extrabonds assocaited with the atom
  residue: The parent residue of the atom
  radius: The radius of the atom
  ffcharge: The forcefield charge on the atom
  hdonor: Whether the atom is a hydrogen donor
  hacceptor: Whether the atom is a hydrogen acceptor
  Returns
  item: The value of the member`

getCoords(self)
  `Return the x,y,z coordinates of the atom in list form
  Returns
  List of the coordinates (list)`

isBackbone(self)
  `Return true if atom name is in backbone, otherwise false
  Returns
  state: 1 if true, 0 if false`

isHydrogen(self)
  `Is this atom a Hydrogen atom?
  returns
  value: 1 if Atom is a Hydrogen, 0 otherwise`

set(self, name, value)
  `Set a member of the Atom class
  Parameters
  name: The name of the member (string)
  value: The value to set the member to
  Possible Values
  type: The type of Atom (either ATOM or HETATM)
  serial: Atom serial number
  name: Atom name
  altLoc: Alternate location
  resName: Residue name
  chainID: Chain identifier
  resSeq: Residue sequence number
  iCode: Code for insertion of residues
  x: Orthogonal coordinates for X in Angstroms.
  y: Orthogonal coordinates for Y in Angstroms.
  z: Orthogonal coordinates for Z in Angstroms.
  occupancy: Occupancy
  tempFactor: Temperature Factor
  segID: Segment identifier
  element: Element symbol
  charge: Charge on the atom
  residue: The parent residue of the atom
  radius: The radius of the atom
  ffcharge: The forcefield charge on the atom
  hdonor: Whether the atom is a hydrogen donor
  hacceptor: Whether the atom is a hydrogen acceptor
  Returns
  item: The value of the member`

Data and non-method functions defined here:

__doc__ = '\n Class Atom\n\n The Atom class inhe... HETATM objects into a\n single class.\n '

__module__ = 'structures'

class Chain
`` | `Chain class The chain class contains information about each chain within a given Protein object.`

Methods defined here:

__init__(self, chainID)
  `Initialize the class
  Parameters
  chainID: The chainID for this chain as denoted in
  the PDB file (string)`

addResidue(self, residue)
  `Add a residue to the chain
  Parameters
  residue: The residue to be added (Residue)`

get(self, name)
  `Get a member of the Chain class
  Parameters
  name: The name of the member
  Possible Values
  ID: The ID of the chain
  Residues: The list of residues within the Chain
  Returns
  item: The value of the member`

getAtoms(self)
  `Return a list of Atom objects contained in this chain
  Returns
  atomlist: List of Atom objects (list)`

numAtoms(self)
  `Get the number of atoms for the chain
  Returns
  count: Number of atoms in the chain (int)`

numResidues(self)
  `Get the number of residues for the chain
  Returns
  count: Number of residues in the chain (int)`

renumberResidues(self)
  `Renumber Atoms based on actual Residue number and not PDB resSeq`

Data and non-method functions defined here:

__doc__ = '\n Chain class\n\n The chain class co...ain within a given\n Protein object. \n '

__module__ = 'structures'

class Residue
`` | `Residue class The residue class contains a list of Atom objects associated with that residue and other helper functions.`

Methods defined here:

__init__(self, atoms, sampleAtom)
  `Initialize the class
  Parameters
  atoms: A list of Atom objects to be stored in this class
  (list)
  sampleAtom: The final listed atom of the residue (Atom)`

addAtom(self, atom)
  `Add the atom object to the residue.
  Parameters
  atom: The object to be added (ATOM)`

addChiangle(self, value)
  `Add the value to the list of chiangles
  Parameters
  value: The value to be added (float)`

addDebumpAtom(self, atom)
  `Add an atom to the check for debumping
  Parameters
  atom: The atom to add to the list`

addMissing(self, value)
  `Add the value to the list of missing atoms
  Parameters
  value: The name of the missing atom (string)`

checkAtomNames(self)
  `Check to see if there are any misnamed hydrogens within the
  residue. Converts hydrogens of type 1HH1 and 2H* to HH11 and
  H*2 to easily compare with the Amino Acid definition file. Also
  converts H*1 and H*2 to H*2 and H*3 when necessary. Rename the
  atom and update the residue.`

createAtom(self, name, newcoords, type)
  `Add a new atom object to the residue. Uses an atom
  currently in the residue to seed the new atom
  object, then replaces the coordinates and name accordingly.
  Parameters
  name: The name of the new atom (string)
  newcoords: The x,y,z coordinates of the new atom (list)
  type: The type of atom, ATOM or HETATM`

get(self, name)
  `Get a member of the Residue class
  Parameters
  name: The name of the member (string)
  Possible Values
  atoms: The atoms in the residue
  name: The name of the residue
  chainID: The chainID associated with the residue
  resSeq: The sequence number of the residue
  icode: The iCode of the residue
  SSbonded: 1 if the residue has a SS bond, 0 otherwise
  SSbondpartner: The residue of the bond partner
  type: The type associated with this residue
  isNterm: 1 if the residue is the N-Terminus, 0 otherwise
  isCterm: 1 if the residue is the C-Terminus, 0 otherwise
  missing: List of missing atoms of the residue
  Returns
  item: The value of the member`

getAtom(self, name)
  `Retrieve an atom from the mapping
  Parameters
  resname: The name of the residue to retrieve (string)`

getCharge(self)
  `Get the total charge of the residue. In order to get rid
  of floating point rounding error, do the string
  transformation.
  Returns:
  charge: The charge of the residue (float)`

numAtoms(self)
  `Get the number of atoms for the residue
  Returns
  count: Number of atoms in the residue (int)`

removeAtom(self, atomname)
  `Remove an atom from the residue object.
  Parameters
  atomname: The name of the atom to be removed (string)`

renameAtom(self, oldname, newname)
  `Rename an atom to a new name
  Parameters
  oldname: The old atom name (string)
  newname: The new atom name (string)`

set(self, name, value)
  `Set a member of the Residue class to a specific value
  Parameters
  name: The name of the object to set (string)
  value: The object to append
  Possible Values
  atoms: The atoms in the residue
  name: The name of the residue
  chain: The chainID associated with the residue
  resSeq: The sequence number of the residue
  icode: The iCode of the residue
  SSbonded: 1 if the residue has a SS bond, 0 otherwise
  SSbondpartner: The residue of the bond partner
  type: The type associated with this residue
  isNterm: 1 if the residue is the N-Terminus, 0 otherwise
  isCterm: 1 if the residue is the C-Terminus, 0 otherwise
  isDirty: 1 if the residue is not missing atoms,
  0 otherwise
  Notes
  resSeq points to the residue.setResSeq function
  Returns
  item: The value of the member`

setResSeq(self, value)
  `Set the atom field resSeq to a certain value and
  change the residue's information. The icode field is no longer
  useful.
  Parameters
  value: The new value of resSeq (int)`

updateIntraBonds(self, defresidue)
  `Update the IntraBonds for each atom in the residue
  Parameters
  defresidue: The definition residue (DefinitionResidue)`

Data and non-method functions defined here:

__doc__ = '\n Residue class\n\n The residue clas...\n residue and other helper functions.\n '

__module__ = 'structures'

Data
`` |  | BACKBONE = ['N', 'CA', 'C', 'O', 'O2', 'HA', 'HN', 'H', 'tN'] __author__ = 'Todd Dolinsky' __date__ = '22 October 2003' __file__ = './structures.pyc' __name__ = 'structures'

Author
`` |  | Todd Dolinsky